using System;
using System.Collections.Generic;
using System.Text;

using System.Runtime.InteropServices;
namespace WindowsApplication1
{
    public class OE
    {
        [Guid("E70C92AA-4BFD-11d1-8A95-00C04FB951F3"),
        InterfaceType(ComInterfaceType.InterfaceIsIUnknown)]
        private interface IStoreNamespace
        {
            void Initialize(
            [In, MarshalAs(UnmanagedType.U4)] 
                Int32 hwndOwner,
            [In, MarshalAs(UnmanagedType.U4)]  
                Int32 dwReserved);

            void GetDirectory(
            [In, Out, MarshalAs(UnmanagedType.LPStr)]  
                StringBuilder pszPath,
            [In, MarshalAs(UnmanagedType.U4)]  
                Int32 cchMaxPath);

            void OpenSpecialFolder(
            [In, MarshalAs(UnmanagedType.U4)] 
                Int32 sfType,
            [In, MarshalAs(UnmanagedType.U4)] 
                Int32 dwReserved,
            [Out, MarshalAs(UnmanagedType.Interface)]
                out object ppFolder);

            void OpenFolder(
            [In, MarshalAs(UnmanagedType.U4)] 
                Int32 dwFolderId,
            [In, MarshalAs(UnmanagedType.U4)] 
                Int32 dwReserved,
            [Out, MarshalAs(UnmanagedType.Interface)]
                out object ppFolder);

            void CreateFolder(
            [In, MarshalAs(UnmanagedType.U4)] 
                Int32 dwParentId,
            [In, MarshalAs(UnmanagedType.LPStr)]  
                String pszName,
            [In, MarshalAs(UnmanagedType.U4)] 
                Int32 dwReserved,
            [Out, MarshalAs(UnmanagedType.U4)]
                out Int32 pdwFolderId);

            void RenameFolder(
            [In, MarshalAs(UnmanagedType.U4)] 
                Int32 dwFolderId,
            [In, MarshalAs(UnmanagedType.U4)]
                Int32 dwReserved,
            [In, MarshalAs(UnmanagedType.LPStr)]  
                string pszNewName);

            void MoveFolder(
            [In, MarshalAs(UnmanagedType.U4)] 
                Int32 dwFolderId,
            [In, MarshalAs(UnmanagedType.U4)] 
                Int32 dwParentId,
            [In, MarshalAs(UnmanagedType.U4)] 
                Int32 dwReserved);

            void DeleteFolder(
            [In, MarshalAs(UnmanagedType.U4)] 
                 Int32 dwFolderId,
            [In, MarshalAs(UnmanagedType.U4)] 
                 Int32 dwReserved);

            void GetFolderProps(
            [In, MarshalAs(UnmanagedType.U4)] 
                Int32 dwFolderId,
            [In, MarshalAs(UnmanagedType.U4)] 
                Int32 dwReserved,
            [Out, MarshalAs(UnmanagedType.Struct)] 
                  out _FOLDERPROPS pProps);

           void CopyMoveMessages(
               [In, MarshalAs(UnmanagedType.Interface)]
                object pSource,
               [In, MarshalAs(UnmanagedType.Interface)]
                object pDest,
                [In, MarshalAs(UnmanagedType.Struct)]
                  MESSAGEIDLIST pMsgIdList,
                [In, MarshalAs(UnmanagedType.U4)] 
               Int32 dwFlags,
               [In, MarshalAs(UnmanagedType.U4)] 
               Int32 dwFlagsRemove,
               [In, MarshalAs(UnmanagedType.Interface)]
                object pProgress  
               );

            
            void RegisterNotification(
              [In, MarshalAs(UnmanagedType.U4)] 
                Int32 dwReserved,
              [In, MarshalAs(UnmanagedType.U4)] 
                Int32 hwnd );

            void UnregisterNotification(
                [In, MarshalAs(UnmanagedType.U4)] 
                Int32 dwReserved,
                 [In, MarshalAs(UnmanagedType.U4)] 
                Int32 hwnd );

            void CompactAll( 
                  [In, MarshalAs(UnmanagedType.U4)] 
                 Int32 dwReserved );

            [PreserveSig]
            Int32 GetFirstSubFolder(
               [In, MarshalAs(UnmanagedType.U4)] 
                Int32 dwFolderId,
                [Out, MarshalAs(UnmanagedType.Struct)] 
                  out _FOLDERPROPS pProps,
                [Out, MarshalAs(UnmanagedType.U4)] 
                out Int32 phEnum);

            
            [PreserveSig]
            Int32 GetNextSubFolder(
                [In, MarshalAs(UnmanagedType.U4)]
                Int32 hEnum,
                [Out, MarshalAs(UnmanagedType.Struct)] 
                  out _FOLDERPROPS pProps);

            void GetSubFolderClose(
            [In, MarshalAs(UnmanagedType.U4)]
                Int32 hEnum);


        }

        
        [StructLayout(LayoutKind.Sequential, Pack = 1, CharSet = CharSet.Ansi)]
        internal unsafe struct _FOLDERPROPS
        {
            internal Int32 cbSize;
            internal Int32 dwFolderId;
            internal Int32 cSubFolders;
            internal Int32 sfType;
            internal Int32 cUnread;
            internal Int32 cMessage;
            internal fixed byte szName[256];
        } ;
        public struct FOLDERPROPS
        {
            public Int32 cbSize;
            public Int32 dwFolderId;
            public Int32 cSubFolders;
            public Int32 sfType;
            public Int32 cUnread;
            public Int32 cMessage;
            public Int32 hEnum;
            public string szName;

        } ;

        
        [StructLayout(LayoutKind.Sequential, Pack = 1, CharSet = CharSet.Ansi)]
        private struct MESSAGEIDLIST {
            private Int32 cbSize;
            private Int32 cMsgs;
            private Int32[] prgdwMsgId;
        }


        private object OECOM;
        private IStoreNamespace OEFolders;
        public OE()
        {
            Type OEType = Type.GetTypeFromCLSID(new Guid("{E70C92A9-4BFD-11d1-8A95-00C04FB951F3}"));
            OECOM = Activator.CreateInstance(OEType);
            OEFolders = OECOM as IStoreNamespace;
            OEFolders.Initialize(0, 0);
        }

        public string getDirectory()
        {
            StringBuilder path = new StringBuilder(256);
            OEFolders.GetDirectory(path, 256);
            return path.ToString();
        }

        public Int32 createFolder(Int32 parentID, string newfoldername)
        {
            Int32 folderID;
            OEFolders.CreateFolder(parentID, newfoldername, 0,out folderID);
            return folderID;
        }

        public void renameFolder(Int32 folderID,string newfoldername)
        {
            OEFolders.RenameFolder(folderID,0,newfoldername);
        }

        public void moveFolder(Int32 folderID,Int32 parentID)
        {
            OEFolders.MoveFolder(folderID,parentID,0);
        }
        public void deleteFolder(Int32 folderID)
        {
            OEFolders.DeleteFolder(folderID, 0);
        }

        
        public FOLDERPROPS GetNextSubFolder(Int32 Id,Int32 hEnum)
        {
            _FOLDERPROPS FP = new _FOLDERPROPS();
            FP.cbSize = Marshal.SizeOf(FP);
            Int32 result;
            if (hEnum == 0)
            {
                result = OEFolders.GetFirstSubFolder(Id, out FP, out hEnum);
            }
            else
            {
                result = OEFolders.GetNextSubFolder(hEnum, out FP);
            }
                FOLDERPROPS fp = transfer(FP);
               
                if (result != 0)
                {
                    if(hEnum!=0) OEFolders.GetSubFolderClose(hEnum);
                    hEnum = 0;
                }
                fp.hEnum = hEnum;
             return fp;
        }

        public void GetSubFolderClose(Int32 hEnum)
        {
            OEFolders.GetSubFolderClose(hEnum);

        }

        private FOLDERPROPS transfer(_FOLDERPROPS FP)
        {
            FOLDERPROPS fp = new FOLDERPROPS();
            fp.cbSize = FP.cbSize;
            fp.cMessage = FP.cMessage;
            fp.cSubFolders = FP.cSubFolders;
            fp.cUnread = FP.cUnread;
            fp.dwFolderId = FP.dwFolderId;
            fp.hEnum = 0;
            fp.sfType = FP.sfType;
            unsafe
            {
                fp.szName = Marshal.PtrToStringAnsi((IntPtr)FP.szName);
            }
            return fp;
        }

    }   
}
